#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#define MAXLINES 40 /* max #lines to be sorted */
char *lineptr[MAXLINES]; /* pointers to text lines */
void writelines(char *lineptr[], int nlines);
void myqsort(char *lineptr[], int left, int right);
void myswap(char *v[], int i, int j);

/* sort input lines */
int main(int argc, char* argv[]){
 int i,nlines;
 
 if( argc < 2){
    printf("\t uso: ptrptr string1 string2 ... stringn\n");
    return(1);
  }
 /* number of input lines read */
 nlines = argc;
 for(i=0; i<nlines;i++){
   lineptr[i] = argv[i];
 }
 printf("nlines %d\n",nlines);
 writelines(lineptr, nlines);
 myqsort(lineptr, 0, nlines-1);
 writelines(lineptr, nlines);
 return 0;
}

/* writelines: write output lines */
void writelines(char *lineptr[], int nlines){
 int i;
 for (i = 0; i < nlines; i++)
   printf("%s\n", lineptr[i]);
}

/* myqsort: sort v[left]...v[right] into increasing order */
void myqsort(char *v[], int left, int right){
 int i, last;
 if (left >= right) /* do nothing if array contains */
  return;
 /* fewer than two elements */
 myswap(v, left, (left + right)/2);
 last = left;
 for (i = left+1; i <= right; i++)
  if (strcmp(v[i], v[left]) < 0)
    myswap(v, ++last, i);
 myswap(v, left, last);
 myqsort(v, left, last-1); 
 myqsort(v, last+1, right);
}

/* myswap: interchange v[i] and v[j] */
void myswap(char *v[], int i, int j){
 char *temp;
 temp = v[i];
 v[i] = v[j];
 v[j] = temp;
}

